/*
 * Wgraphics.c
 *              Motif/Lesstif BGI-like grahphic widget library module
 *
 * Programmer: Park Jae-Ho(jrogue@netian.com), Lee Hai-Young
 *
 * This project is inspired by the WINIO library in UNDOCUMENTED WINDOWS.
 * This library can be copied, modified, used by others,
 * BUT PLEASE PROVIDE THAT ABOVE NOTICE APPEAR IN ALL COPIES OF THIS LIBRARY.
 */

#include <Xm/Xm.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <string.h>
#include "Mgraphics.h"
#include "Wgraphics.h"

/* necessary extern variable */

extern  Display *display ;
extern  MScreen *curScreen ;
extern  char    *BasicColor[] ;
extern  Colormap curColormap ;

void WSetCurPosition( MScreen *target, int ix, int iy ) ;

void WclearScreen ( target )
MScreen *target ;
{
	Wsetnamedcolor( target, "black" );
	Wsetnamedbkcolor( target, "black" );
	/*
	 * Sonne replaced forground color with default background color,
	 * but she forgot to fill pixmap with changed color. So I do it.
	*/
	XFillRectangle( display, target->pixmap, target->gc, 0, 0, 
			target->width, target->height );
	/* inserted by rogue for drawing line immediately */
	XCopyArea( display, target->pixmap, XtWindow( target->screen ),
		target->gc, 0, 0, target->width, target->height, 0, 0) ;
	/* change forground color white */
	Wsetnamedcolor( target, "white" );
	Wcontrol() ;
}

/* implemented fully by rogue */
int  Wgetmaxx ( target )
MScreen *target ;
{
	return ( target->width );		
}

/* implemented fully by rogue */
int Wgetmaxy ( target )
MScreen *target ;
{
	return ( target->height );		
}

void Wputpixel ( target, ix, iy )
MScreen *target ;
int    ix, iy ;
{
	XDrawPoint( display, target->pixmap, target->gc, ix, iy ) ;
	WSetCurPosition( target, ix, iy ) ;
	Wcontrol() ;	
}

void Wline ( target , ixStart, iyStart, ixFinish, iyFinish )
MScreen *target ;
int  ixStart, iyStart, ixFinish, iyFinish ;
{
	XDrawLine( display, target->pixmap, target->gc,  
			ixStart, iyStart, ixFinish, iyFinish ) ;
	WSetCurPosition( target, ixFinish, iyFinish ) ;

	/* inserted by rogue for drawing line immediately */
	XCopyArea( display, target->pixmap, XtWindow( target->screen ),
		target->gc, 0, 0, target->width, target->height, 0, 0) ;
	Wcontrol() ;
}

void WSetCurPosition( target, ix, iy ) 
MScreen *target ;
int 	ix, iy ;
{
	target->curix = ix ;
	target->curiy = iy ;
}

void Wsetnamedcolor ( target, colorname )
MScreen *target ;
char    *colorname ;
{
	XColor c1, c2 ;

	XAllocNamedColor( display, curColormap, colorname, &c1, &c2 ) ;

	XSetForeground( display, target->gc, c1.pixel ) ;
}

void Wsetnamedbkcolor ( target, colorname )
MScreen *target ;
char   *colorname ;
{
        XColor c1, c2 ;

        XAllocNamedColor( display, curColormap, colorname, &c1, &c2 ) ;

	XSetBackground( display, target->gc, c1.pixel ) ;
}
