/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :     L O A D . C                              //
//                                                            //
//         C Լ  Լ  ڵ                       //
//                                                            //
//************************************************************//

#include <a.out.h>
#include <fcntl.h>
#include "emptr.h"
#include "String.h"

static String symtab;
static char y = 'a';

extern "C" vptp load(const char *filename) {
    // load    ũ ؼ ο a.out
    // µ,  a.out  ȣ  ذϱ  
    // ȰѴ. ׸  ο   .text .data ũ⸦
    // ؼ Ӱ Ҵ ޸  оδ. ̴ 
    //  ϸ, ܺ  ũ  Բ ϵ
    // Ǿ ִ. ̿ Ҿ C  ܼ C ȣ 
    // ֵ .

    int errcode = 0;
    String newfile;
    char buf[256];
    long adx, oadx;
    unsigned char *ldadx;
    struct exec Exec;
    int fd, wc;

    // ù ° ķ մ ⺻ Ѵ. a.out
    // ɺ ̺ ϴ   ̸, Ź
    //   , ũ Ⱑ  
    // ̸ Ѵ. ۾ Կ    Ѵ.

    if (!symtab.length()) {
        symtab = "a.out"; newfile = "b.out";
    } else {
        symtab = String(++y) + ".out";
        newfile = String(y+1) + ".out";
    }

    //  ޸  ãƼ,  ޸  ¦ 
    // 谡 ǵ äִ´.
    oadx = (long)sbrk(0);
    adx = oadx + PAGSIZ - (oadx%PAGSIZ);

    //  a.out   .o   ũ  ϵ
    //   . ⼭ ο ڵ尡  ޸ 
    // ũϵ Ѵ.
    sprintf(buf, "ld -N -Ttext %X -A %s %s -o %s",
        adx, (const char*)symtab, filename,
        (const char*)newfile);
    printf("<%s>\n", buf);
    if ((errcode=system(buf)) != 0) {
        printf("load: link edit returned error code %d\n",
            errcode);
    }
    if (symtab != "a.out") unlink(symtab);

    //   ޸𸮷 Ѵ.
    fd = open(newfile, O_RDONLY);
    if (fd < 0) {
        printf("load: open of \"%s\" failed\n", newfile);
        return 0;
    }

    // ġ    о ؽƮ  ũ⸦ Ѵ.
    read(fd, (char *)&Exec, sizeof(struct exec));

    //  ޸  ι ä, ο α׷ ؽƮ 
    //  ҴѴ.
    sbrk(int(PAGSIZ-(oadx%PAGSIZ)));
    ldadx = (unsigned char *)
        sbrk(int(Exec.a_text + Exec.a_data + Exec.a_bss));

    // Ӱ ũ  о    ģ ּҸ ؼ
    //  μ ִ´.
    wc = read(fd, (char *)ldadx,
	int(Exec.a_text + Exec.a_data));
    close(fd);

    //  ּҸ ȯѴ.
    return (vptp) ldadx;
}
