/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    T R I N A N G L E . C                     //
//                                                            //
//         Ŭ Triangle  ̽                  //
//                                                            //
//************************************************************//

#include "triangle.h"

// Ŭ  
ShapeRep *triangle = 0;
char *Triangle::heap = 0;
size_t Triangle::poolInitialized = 0;

void
Triangle::init() {
    // Triangle      ʱȭ
    //  ڷ  ʱȭ ShapeRep::gcCommon ó ȣϴ 
    // Ѵ.
    triangle = new Triangle(Exemplar(0));
}

Shape
Triangle::make()
{
    // make a default (degenerate) triangle
    // ⺻() ﰢ .
    Triangle *retval = new Triangle;
    retval->p1 = retval->p2 = retval->p3 = Coordinate(0,0);
    retval->exemplarPointer = this;
    return *retval;
}

Shape
Triangle::make(Coordinate pp1, Coordinate pp2, Coordinate pp3)
{
    // ο Triangle ϰ ȯѴ.
    Triangle *retval = new Triangle;
    retval->p1 = pp1;
    retval->p2 = pp2;
    retval->p3 = pp3;
    retval->exemplarPointer = this;
    return *retval;
}

void
Triangle::gc(size_t nbytes) {
    // Triangle ޸ ڷ   Ŭ ִ Ϲ 
    // ÷() Ѵ.
    gcCommon(nbytes, poolInitialized, PoolSize, heap);
}

void
Triangle::draw() {
    //  ܼ Ǯ ﰢ ġ شϴ ̸ Ѵ.
    int Sizeof = poolInitialized? poolInitialized:
        Round(sizeof(Triangle));
    printf("<Triangle object %c>",
        'A' + (((char *)this-(char *)heap)/Sizeof));
}

void
Triangle::move(Coordinate) {
    // . . .
}

void
Triangle::rotate(double) {
    // . . .
}

void *
Triangle::operator new(size_t nbytes) {
    // Ǯ  ʱȭ ʾҰų Triangle Ŭ  ,
    //  ÷Ϳ  ѱ.

    if (poolInitialized - nbytes) {
        gcCommon(nbytes, poolInitialized, PoolSize, heap);
        poolInitialized = nbytes;
    }

    //   ŽѴ.
    Triangle *tp = (Triangle *)heap;
    // ޸  ׽Ʈ ߰ ʿ䰡 ִ.
    while (tp->inUse) {
        tp = (Triangle*)(((char*)tp) + Round(nbytes));
    }

    // ޸ Ʈ  ʱȭѴ.
    tp->gcmark = 0;
    tp->inUse = 1;
    return (void*) tp;
}

void Triangle::operator delete(void *) {
    //  Լ  ȣؼ ȵȴ.  C++
    // new ϸ  Լ ؾ Ѵ.
}

Triangle::Triangle() { }  // ũ vptr  ⿡ ִ.

Triangle::Triangle(const Triangle& t) {
    //  
    p1 = t.p1;
    p2 = t.p2;
    p3 = t.p3;
}

Triangle::Triangle(Exemplar e) : ShapeRep(e) {
    // Triangle exemplar .
}

Shape
Triangle::make(Coordinate) {
    //  Լ --  ȣؼ ȵȴ.
    return *aShape;
}

Shape
Triangle::make(Coordinate, Coordinate) {
    //  Լ --  ȣؼ ȵȴ.
    return *aShape;
}
