/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    V 2 T R I A N G L E . H                   //
//                                                            //
//         Ŭ Triangle(2)   ̽      //
//                                                            //
//************************************************************//

#define _TRIANGLE_H
#ifndef _TRIANGLE_H
#include "shaperep.h"
#include "coordinate.h"

class Triangle: public ShapeRep {
public:
    // Triangle.h Ȱ. , Triangle::move ο Ǹ   Ѵ.
    Shape make();
    Shape make(Coordinate, Coordinate, Coordinate);
    Triangle();
    void draw();
    void move(Coordinate);
    void rotate(double);
    void *operator new(size_t);
    void operator delete(void *);
    void gc(size_t = 0);
    Triangle(Exemplar);
    static void init();
private:
    static void poolInit(size_t);
    Shape make(Coordinate) { return *aShape; }
    Shape make(Coordinate, Coordinate) { return *aShape; }
    Coordinate p1, p2, p3;
private:
    static char *heap;
    static size_t poolInitialized;
    enum { PoolSize = 10 };
};

extern ShapeRep *triangle;
#endif
