/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    V 3 T R I A N G L E . H                   //
//                                                            //
//         3 Triangle Ŭ  ڷ                //
//                                                            //
//************************************************************//

#ifndef _TRIANGLE_H
#define _TRIANGLE_H
#include "shaperep.h"
#include "coordinate.h"

//  Ŭ ο(3) ﰢ Ŭ ̴.
//  Ӽ ִ.

class Triangle: public ShapeRep {
public:
    Shape make();
    Shape make(Coordinate, Coordinate, Coordinate);
    Triangle();
    void draw();
    void move(Coordinate);
    void rotate(double);
    void *operator new(size_t);
    void operator delete(void *);
    void gc(size_t = 0);
    Thing *cutover();
    Triangle(Exemplar);
    static void init();
private:
    static void poolInit(size_t);
    Shape make(Coordinate) { return *aShape; }
    Shape make(Coordinate, Coordinate) { return *aShape; }
    Coordinate p1, p2, p3;
    enum Color { Black, White } color;
private:
    static char *heap;
    static size_t poolInitialized;
    enum { PoolSize = 10 };
};

extern ShapeRep *triangle;
#endif
