#include "polygon.hpp"
#include <iostream>
#include <dlfcn.h>

int main() {
    using std::cout;
    using std::cerr;

    // ﰢ ̺귯 ø.
    void* triangle = dlopen("./triangle.so", RTLD_LAZY);
    if (!triangle) {
        cerr << "Cannot load library: " << dlerror() << '\n';
        return 1;
    }

    // Լ ȣ ̾Ƴ.
    create_t* create_triangle = (create_t*) dlsym(triangle, "create");
    destroy_t* destroy_triangle = (destroy_t*) dlsym(triangle, "destroy");
    if (!create_triangle || !destroy_triangle) {
        cerr << "Cannot load symbols: " << dlerror() << '\n';
        return 1;
    }

    // Ŭ νϽ .
    polygon* poly = create_triangle();

    // Ŭ .
    poly->set_side_length(7);
    cout << "The area is: " << poly->area() << '\n';

    // Ŭ Ҹ.
    destroy_triangle(poly);

    // ﰢ ̺귯 .
    dlclose(triangle);
}
