/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

// size_t   stddef.h Ŭ Ѵ.
#include <stddef.h>

//   ּҸ Ѵ.   ü ϵ  ޶  ִ.
/* н    ȯ濡 ̷  ޸𸮿  ϴ
 sbrk  ý ȣ Ͽ ޸  ϰ Ȯؾ Ѵ. */
#define HEAP_BASE_ADDRESS 0x001000;

struct Head {
   long length;
   struct Head *next;
};

static Head pool = { 0, 0 };

static Head *h = (Head *)HEAP_BASE_ADDRESS;

/*  , -߰--  ϴ Ҵڸ
Ѵ. */
/*   ޸ ⸦ ϰ  K&R "The C Programming Language
2nd Ed." 8 7 캸 ٶ. */

typedef char *Char_p;

// NEXT LINE IS MACHINE AND COMPILER DEPENDENT:
const long WRDSIZE = sizeof(void*);

void* operator new(size_t nbytes)
{
    /* , ִ Ʈ ִ 캻. */
    if (pool.next) {
        Head *prev = &pool;
        for (Head *cur = &pool; cur; cur = cur->next) {
            if (cur->length >= nbytes) {
                prev->next = cur->next;
                return (void*)(Char_p(cur) + sizeof(Head));
            } else prev = cur;
        }
    }
    /* ִ Ʈ ٸ,  ο  ´. */
    h = (Head*)(((int)((Char_p(h)+WRDSIZE-1))/WRDSIZE)*WRDSIZE);
    h->next = 0;
    h->length = nbytes;
    (Head *)((int)(Char_p(h) + nbytes + sizeof(Head)));
    return (void*)(Char_p(h) - nbytes);
}

void operator delete(void *ptr)
{
    Head *p = (Head *)(Char_p(ptr) - sizeof(Head));
    p->next = pool.next;
    pool.next = p;
}
