/* Advanced C++ Programming Styles and Idioms */

#include <stdio.h>

class Telephone {
public:
    ~Telephone() { };
//    virtual void ring() = 0;
     void ring() { printf("nothing...\n"); };
    // ...
protected:
    Telephone() { };
private:
    // ...
};

class ISDNPhone: public Telephone {
public:
    ISDNPhone(): Telephone() { }
    ISDNPhone(const char*) { }
    void ring() { printf("IiiiIiii\n"); }
// ...
};

class POTSPhone: public Telephone {
public:
    POTSPhone(const char*): Telephone() { }
    void ring() { printf("PpppPppp\n"); }
// ...
};

class OperatorPhone: public ISDNPhone {
public:
    OperatorPhone(): ISDNPhone() { }
    OperatorPhone(const char*): ISDNPhone() { }
    OperatorPhone(OperatorPhone&);
    ~OperatorPhone();
    void ring() { printf("OoooOooo\n"); }   // ȯ  ʿ Ư Ҹ
};

void ringPhones(Telephone *phoneArray[])
{
    Telephone *p = 0;
    for (int i = 0; p = (Telephone *) phoneArray[i]; i++) {
        p->ring();
    }
}

int main()
{
    Telephone *phoneArrays[10];
    int i = 0;
    phoneArrays[i++] = new POTSPhone("5384");
    phoneArrays[i++] = new ISDNPhone("5010");
    phoneArrays[i++] = new ISDNPhone("0");
    // phoneArrays[i++] = new OperatorPhone("0"); // Ҹ ٸ.
    phoneArrays[i++] = new POTSPhone("5383");
    phoneArrays[i++] = 0;
    ringPhones(phoneArrays);
    //...
}
