/* Advanced C++ Programming Styles and Idioms */

#include <stdio.h>

class Queue {
friend class QueueIterator;
public:
    void *leave() {
        void *retval;
        if (head == tail) retval = 0;
        else {
            if (--head < 0) head = max - 1;
            retval = rep[head];
        }
        return retval;
    }
    void *first() { return rep[head]; }
    void enter(void *v) {
        if ((head + 1) % max == tail) { /*  --   */ }
        if (--tail < 0) tail = max - 1;
        rep[tail] = v;
    }
    int empty() { return head == tail; }
    Queue() { rep = new void*[max]; head = tail = 0; }
private:
    enum Constants { max = 10 };
    void **rep;
    int head, tail;
};

class QueueIterator {
public:
    QueueIterator(const Queue& q): queue(q), current(q.head) { }
    int next(void* &i) {
        if (current == queue.tail) {
            return 0;
        } else {
            if (--current < 0) current = Queue::max - 1;
            i = queue.rep[current];
            return 1;
        }
    }
    void reset() { current = queue.head; }
private:
    const Queue &queue;
    int current;
};

int main()
{
    int one = 1, two = 2, three = 3, four = 4, five = 5, six = 6,
        seven = 7, eight = 8, nine = 9, ten = 10, eleven = 11, twelve = 12;
    void *i;
    Queue a;
    a.enter(&one);
    a.enter(&two);
    a.enter(&three);
    QueueIterator qi = a;
    while (qi.next(i)) printf("%d ", (int)(*((int*)i));
    printf("\n");
    a.enter(&four);
    a.enter(&five);
    a.enter(&six);
    printf("leaving: "); i = a.leave();
    printf("%d ", (int)(*((int*)i));
    i = a.leave();
    printf("%d ", (int)(*((int*)i));
    i = a.leave();
    printf("%d ", (int)(*((int*)i));
    i = a.leave();
    printf("%d ", (int)(*((int*)i));
    i = a.leave();
    printf("%d\n", (int)(*((int*)i));
    a.enter(&seven);
    a.enter(&eight);
    a.enter(&nine);
    a.enter(&ten);
    a.enter(&eleven);
    a.enter(&twelve);
    QueueIterator qj = a;
    while (qj.next(i)) printf("%d ", (int)(*((int*)i));
    printf("\nleaving: ");
    i = a.leave();
    printf("%d ", (int)(*((int*)i));
    i = a.leave();
    printf("%d\n", (int)(*((int*)i));
    qj.reset();
    while (qj.next(i)) printf("%d ", (int)(*((int*)i));
    printf("\nleaving: ");
    i = a.leave();
    printf("%d ", (int)(*((int*)i));
    i = a.leave();
    printf("%d\n", (int)(*((int*)i));
    return 0;
}
