/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 2-3 */

#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

extern int errno;

// String class definition
//
class String {
public:
    // constructor & descructor
    String() {
        rep = new char[1];
        rep[0] = '\0';
    }

    String(const char* s) {
        int lengthOfOriginal = ::strlen(s) + 1;
        rep = new char[lengthOfOriginal];
        ::strcpy(rep, s);
    }

    String(const String& s) {
        rep = new char[s.length() + 1];
        ::strcpy(rep, s.rep);
    }

    ~String() {
        delete[] rep;
    }

    // other public member functions
    int length() const {
        return ::strlen(rep);
    }
    const char* C_rep() { return rep; }

private:
    char *rep;
};

// Function open declaration & overloaded definitions
//
extern int open(char* file, int oflag, ...);

int open(String& s, int oflag, ...) {
    cout << "open(String& s, int oflag, ...) is invoked." << endl;

    va_list args;
    return open(s.C_rep(), oflag, args);
}

int open(int fd, int oflag, ...) {
    cout << "open(int fd, int oflag, ...) is invoked. " << endl;

    va_list args;
    return fcntl(fd, F_DUPFD, args);
}

int open(FILE* f, int oflag, ...) {
    int filedesc = ::fileno(f);
    cout << "open(FILE* f, int oflag, ...) is invoked. " << endl;

    va_list args;
    return dup(filedesc);
}

// Main for testing
//
int main() {
    FILE *f = fopen("/etc/group", "r");
    String group("/etc/group");

    int fd1 = open("/etc/group", O_RDONLY);
    cout << "fd1: " << fd1 << endl;
    close(fd1);
    int fd2 = open(group, O_RDONLY);
    cout << "fd2: " << fd2 << endl;
    int fd3 = open(fd2, O_NDELAY);
    cout << "fd3: " << fd3 << endl;
    close(fd3);
    close(fd2);
    int fd4 = open(f, O_RDONLY);
    cout << "fd4: " << fd4 << endl;
    close(fd4);
    fclose(f);

    return 0;
}
