/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 2-8 */

// stack implementation with no size limitation

#include <iostream.h>
#include <cstring>

const int STACK_SIZE = 10;

class Stack {
public:
    Stack();
    Stack(int);
    ~Stack();
    long top() const;
    long pop();
    void push(long);
    int  size();    // for debugging

private:
    long *items;
    int  sp;
    int  max;
};

Stack::Stack() {
    items = new long[STACK_SIZE];
    sp    = -1;
    max   = STACK_SIZE;
}

Stack::Stack(int s) {
    items = new long[s];                       
    sp    = -1;
    max  = s;
}

Stack::~Stack() {
    delete[] items;         
}

long Stack::top() const {
    return items[sp];
}

long Stack::pop() {
    return items[sp--];
}

void Stack::push(long i) {
    if (sp == max - 1) {
        long* longeritems = new long[max + STACK_SIZE];
        memcpy(longeritems, items, sizeof(long) * max);
			
        delete[] items;
        items  = longeritems;
        max  += STACK_SIZE;
    }

    items[++sp] = i;
}

int Stack::size() {
    return max;
}

int main()
{
    Stack q(1);        
    cout << "stack size is " << q.size() << endl << endl;

    q.push(23);
    cout << "push " << q.top() << endl;
    cout << "stack size is " << q.size() << endl << endl;

    q.push(11);
    cout << "push " << q.top() << endl;
    cout << "stack size is " << q.size() << endl << endl;

    cout << "pop " << q.pop() << endl;
    cout << "pop " << q.pop() << endl;
    cout << "stack size is " << q.size() << endl << endl;

    return 0;
}
