/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-11 */

#include <stdio.h>
#include <iostream.h>

// implicitly defined for preventing duplicated definition "open" in <fcntl.h>
#define O_RDONLY 00

class String {
public:
    // ...
    String(char* s) { cout << "String: String char *" << endl; }
    operator const char*() const { cout << "String: char*()" << endl; return "dummy"; }
    // ...
};

extern "C" {
    int open(const char*, int ...);
}

int open(String, int ...) { 
    cout << "open(String, int ...)" << endl; return 0; 
}

int main() {
    cout << "int i = open(\"abcd\", O_RDONLY);" << endl;
    int i = open("abcd", O_RDONLY);

    cout << "int j = open(String(\"abcd\"), O_RDONLY);" << endl;
    int j = open(String("abcd"), O_RDONLY);
    
    String abcd = "abcd";
    cout << "int k = open(abcd, O_RDONLY);" << endl;
    int k = open(abcd, O_RDONLY);

    cout << "int k = open((const char*) abcd, O_RDONLY);" << endl;
    int l = open((const char*) abcd, O_RDONLY);
    
    return 0;
}
