/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 4-2 */

#include <iostream.h>
#include <stdio.h>

// Sample class inheritance
//
class classA {
public:
    classA(int i) { dataA = i; }
    ~classA() { dataA = 0; }

    int  getDataA() const      { return dataA; }
    void setDataA(const int i) { dataA = i; }
    void print() const         { cout << "classA.dataA = " << dataA << endl; }

private:
    int dataA;
};

class classB : public classA {
public:
    classB(int i) : classA(i) { dataB = i; }
    ~classB() { dataB = 0; }
   
    int  getDataB() const      { return dataB; }
    void setDataB(const int i) { dataB = i; }
    void print() const         { classA::print(); 
                                 cout << "classB.dataB = " << dataB << endl; }
private:
    int dataB;
};

// Equivalent structure
//
typedef struct structureA {
    int __dataA;
} structA;

void structAconstruct(structA* psa, int i) { psa->__dataA = i; }
void structAdestruct(structA* psa)         { }
int  structAgetDataA(structA* psa)         { return psa->__dataA; }
void structAsetDataA(structA* psa, int i)  { psa->__dataA = i; }
void structAprint(structA* psa)            { printf("structA.__dataA = %d\n", psa->__dataA); }

typedef struct structureB {
    structA super;
    int     __dataB;
} structB;

void structBconstruct(structB* psb, int i) { 
    structAconstruct(&(psb->super), i);
    psb->__dataB = i;
}

void structBdestruct(structB* psb) {
    psb->__dataB = 0;
    structAdestruct(&(psb->super));
}

int  structBgetDataB(structB* psb)         { return psb->__dataB; }
void structBsetDataB(structB* psb, int i)  { psb->__dataB = i; }
void structBprint(structB* psb)            { structAprint(&(psb->super));
                                             printf("structB.__dataB = %d\n", psb->__dataB); }

// Function main() for testing
//
int main() {
    // using class
    classB   cb(5);
    classA*  pca = &cb;
    
    pca->setDataA(10);
    cb.print();

    // using struct
    structB  sb;
    structA* psa;

    structBconstruct(&sb, 5);
    psa = (structA*)&sb;
    structAsetDataA(psa, 10);
    structBprint(&sb);
    structBdestruct(&sb);


    return 0;
}

