/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 7-6 */

#include <iostream.h>
#include <string>

using namespace std;

template<class T>
class CountedClassObject {
public:
    CountedClassObject() : rep(new CountedClassObject) {}
    CountedClassObject(const CountedClassObject& c) : rep(c.rep) { rep->count++; }
    CountedClassObject(const T& t): rep(new CountedClassObjectRep(new T(t))) {}
    ~CountedClassObject() { if (--rep->count <= 0) delete rep; }

    CountedClassObject& operator=(const CountedClassObject& c) {
        c.rep->count++;
        if (--rep->count <= 0) delete rep;
        rep = c.rep;
        return *this;
    }

    void print() {
        cout << "reference count = " << rep->count << endl;
        cout << "class object address = " << (rep->rep) << endl << endl;
    }

private:
    struct CountedClassObjectRep {
        int count;
        T*  rep;
        CountedClassObjectRep(T* t) : count(1) {
            rep = t? t: new T;
        }
    } *rep;
};

int main() {
    CountedClassObject<string>* c1 = new CountedClassObject<string>(string("sample string")); 
    c1->print(); 
    
    CountedClassObject<string>* c2 = new CountedClassObject<string>(*c1);
    c2->print();

    delete c1;
    c2->print();

    delete c2;

    return 0;
}

